/* NS1 - Nick Services ns-src/free_lists.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void free_rnickinfo()
{
   struct nickinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Nicklist\n", date());
   current = nickhead;
   while(current != NULL)
   {
      if(current == nickhead) nickhead = nickhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_nicklist()
{
   struct nickinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Nicklist\n", date());
   current = nickhead;
   while(current != NULL)
   {
      if(current == nickhead) nickhead = nickhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}
 
void free_burst()
{
   struct burstinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Burst\n", date());
   current = bursthead;
   while(current != NULL)
   {
      if(current == bursthead) bursthead = bursthead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}
