#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <unistd.h>
#include <stdarg.h>
#include <ctype.h>
#include <errno.h>
#include <sys/time.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <proto.h>

#undef DEBUG
/*
#define DEBUG
*/
#define NUMNICKLOG 6
#define NUMNICKMASK 63
#define HOPCOUNT 1
#define MAXLEN 524
#define MAXTOPIC 500
#define MAXBUF 1024
#define CFG_FILE "config/nserve.conf"
#define COM_FILE "config/commands.dat"
#define RNICKLIST "database/rnick.n"
#define BNICKLIST "database/badnick.n"
#define TMP_FILE "temp.n"
#define BOT_LOG "logs/bot.log"
#define PURGE_LOG "logs/purge.log"
#define LOG_FILE "logs/cmd.log"
#define ERRLOG_FILE "logs/err.log"
#define NICKLEN 50
#define PORTLEN 10
#define MAXDEF 80
#define TRUE 1
#define FALSE 0             /* 175 */
#define PINGINTERVAL 175   /* This should be less than ALARMINTERVAL */
#define KILLINTERVAL 60
#define SECPERHR 3600
#define WAITSEC 15
#define UWAITSEC 0
#define ALARMINTERVAL 15   /* This should be greater than PINGINTERVAL */
#define SETTIMEINTERVAL 3600
#define PURGEINTERVAL 180 /*1 day [86400] */
/*#define PURGEINTERVAL 43200 1 day [86400] */
#define REGLINE 21600
#define RECHECK 5          /* Recheck to connect to server in seconds */
#define CTCP_DELIM_CHAR '\001'
#define NUMNICKBASE 64
#define MAXNUM 4096
#define Reg1 register
#define Reg2 register
#define Reg3 register
#define BadPtr(x) (!(x) || (*(x) == '\0'))

#include <structs.h>
#include <globals.h>
