/* NS1 - Nick Services ns-src/ip_tools.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

int is_num(char *num)
{
   while(*num)
   {
     if(!isdigit(*num)) return 0;
     num++;
   }
   return 1;
}

int countdots(char *addr)
{
   int i = 0;
   while(*addr)
   {
     if(*addr == '.' )
     {
       i++;
     }
     addr++;
   }
   return(i);
}

char *getghost(char *nick)
{
   struct nickinfo *current;
   if(nick == NULL) return NULL;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick, current->nick))
      {
         return(current->host);
      }
      current = current->next;
   }
   return NULL;
}

char *getuserhost(char *nick)
{
   struct nickinfo *current;
   char *user;
   if(nick == NULL) return NULL;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick, current->nick))
      {
         user = current->user;
         if(*user == '~') user++;
         sprintf(linebuff, "%s@%s", user, current->host);
         return(linebuff);
      }
      current = current->next;
   }
   return NULL;
}

char *convert_addr(char *who, char *address)
{
   struct nickinfo *nick;
   char *hostip, *ptr2, backup[1000], *addr;
   backup[0]='\0';
   if(!is_ip(address))
   {
      if(addr = strchr(address, '@')) *addr++ = '\0';
      nick = nickhead;
      while(nick != NULL)
      {
         if(!strcasecmp(who, nick->nick))
         {
            hostip = dectoip(base64toint(nick->base64));
         }
         nick = nick->next;
      }
      strcpy(userhost, hostip);
      if(ptr2 = strrchr(userhost, '.')) *++ptr2 = '*';
      *++ptr2 = '\0';
      if(strlen(address) > 8)
      {
         address[8] = '*';
         address[9] = '\0';
      }
      sprintf(backup, "%s@%s", address, userhost);
      strcpy(userhost, backup);
      return userhost;
   }
   return NULL;
}

int is_ip(char *addr)
{
   while(*addr)
   {
     if(!isdigit(*addr)&&( *addr != '.' )) return 0;
     addr++;
   }
   return 1;
}

char *getnickuserhost(char *nick)
{
   struct nickinfo *current;
   char *newuser = NULL;

   if(nick == NULL) return NULL;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick, current->nick))
      {
         newuser = current->user;
         if(newuser[0] == '~')
         {
            newuser++;
         }
         sprintf(linebuff1, "%s!%s@%s", current->nick, newuser, current->host);
         return(linebuff1);
      }
      current = current->next;
   }
   return NULL;
}

