/* NS1 - Nick Services ns-src/join_msgchan.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void join_msgchan()
{
   struct burstinfo *burst;
   char *usernum = NULL;
   int gotit = 0;

   usernum=get_usernum(bot.nick);
   burst = bursthead;
   if(ymsgchan)
   {
      while(burst != NULL)
      {
         if(!strcasecmp(msg_chan, burst->channel))
         {
            send_to_server("%c BURST %s %ld %s:o\n", convert2y[server_num], msg_chan, burst->chanstamp, usernum);
            send_to_server(":%s MODE %s +mints\n", bot.nick, msg_chan);
            gotit = 1;
         }
         burst = burst->next;
      }
      if(!gotit)
      {
         send_to_server("%c BURST %s %ld %s:o\n", convert2y[server_num], msg_chan, time(NULL), usernum);
         send_to_server(":%s MODE %s +mints\n", bot.nick, msg_chan);
      }
   }
   send_to_server("%c END_OF_BURST\n", convert2y[server_num]);
   load_commands();
   free_burst();
}

void inviteme(char *who, char *rest)
{
   char *nwho = NULL, *nick = NULL;
   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   if(!ymsgchan)
   {
      send_to_server(":%s NOTICE %s : Messege Channel is not enabled\n",bot.nick, nwho);
      return;
   }
   if(rest != NULL)
   {
     if(strlen(rest) > 25 && *rest == '#') return;
     nick = strtok(rest, " ");
     send_to_server(":%s INVITE %s %s\n",bot.nick, nick, msg_chan);
   }
   else
     send_to_server(":%s INVITE %s %s\n",bot.nick, who, msg_chan);
}
