/* NS1 - Nick Services ns-src/num_tools.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void serv_unused(char *server)
{
   int i;

   for(i=0;i<NUMNICKBASE;i++)
   {
      if(!strcasecmp(server,servinfo[i].server))
      {
         servinfo[i].used = FALSE;
         return;
      }
   }
}

void serv_used(char chars, char *server)
{
   int i;

   for(i=0;i<NUMNICKBASE;i++)
   {
      if(chars == servinfo[i].chars)
      {
         servinfo[i].used = TRUE;
         strcpy(servinfo[i].server, server);
         return;
      }
   }
}

void delete_usernum(char *numeric)
{
  int i;

  for(i=0;i<MAXNUM;i++)
  {
    if(!strcmp(numeric, usernums[i].chars))
    {
       usernums[i].used=FALSE;
       return;
    }
  }
}

char *num2serv(char num)
{
  int i;
  char *entry=(char *)NULL;

  for(i=0;i<NUMNICKBASE;i++)
  {
    if(num == servinfo[i].chars)
    {
      entry=servinfo[i].server;
      break;
    }
  }
  return(entry);
}

char *nick2num(char *who)
{
  struct nickinfo *current;

  current = nickhead;
  while(current != NULL)
  {
     if(!strcasecmp(who, current->nick))
     {
        return(current->numeric);
     }
     current=current->next;
   }
   return NULL;
}

char *num2nick(char *num)
{
  struct nickinfo *current;

  current = nickhead;
  while(current != NULL)
  {
     if(!strcmp(num, current->numeric))
     {
        return(current->nick);
     }
     current=current->next;
   }
   return NULL;
}

char get_free_servnum(char *server, char numeric)
{ 
  int i;
  char entry=(char)NULL;
  
  for(i=0;i<NUMNICKBASE;i++) 
  { 
    if ( servinfo[i].used == FALSE && servinfo[i].chars == numeric)
    { 
      servinfo[i].used = TRUE;
      strcpy(servinfo[i].server, server);
      entry=servinfo[i].chars;
      break;
    }
  }
  return(entry);
}

char *get_free_usernum(char *nick)
{ 
  int i;
  char *entry=(char *)NULL;
  
  for(i=0;i<MAXNUM;i++) 
  {
    if(usernums[i].used == FALSE)
      {
         strcpy(usernums[i].nick, nick);
         usernums[i].used = TRUE;
         entry=usernums[i].chars;
         break;
      }
   }
  return(entry);
}

char *get_usernum(char *nick)
{
  int i;
  char *entry=(char *)NULL;

  for(i=0;i<MAXNUM;i++)
  {
    if(!strcasecmp(usernums[i].nick, nick))
    {
      entry=usernums[i].chars;
      break;
    }
  }
  return(entry);
}
