/* NS1 - Nick Services ns-src/parse.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse(char *line)
{
   struct nickinfo *nick;
   int i = 0, nick_server = 0, id = 0;
   char *sample, *nline, *cmd, *rest, *who, test[10000], num[300], *server, *nwho;
   char *samp1, *samp2, *samp3, *samp4, *samp5, *samp6;
   strip_newline(line);   /* get those \r and \n out of the way */
   if(strlen(line) > 524)
   {
       return;
   }
   strcpy(test, line);
   if(is_serv(test) || *line == ':') 
   {
      if (!strncmp(line,":SERVER",7))
         nick_server = 1;
      line++;  /* get rid of the ':' */
         if(cmd = strchr(line, ' ')) *cmd++ = '\0';  /* the command */
         who = line;  /* who sent the message? */
         if(rest = strchr(cmd, ' ')) *rest++ = '\0';
         else
         {
            if(strcmp(cmd, "EOB_ACK") && strcmp(cmd, "END_OF_BURST") && strcmp(cmd, "AWAY"))
            {
               if(who = strchr(line, ' ')) *who++ = '\0';
               cmd = line;
            }
            rest = NULL;
         }
   } 
   else 
   {
      strcpy(test, line);
      who=strtok(test, " ");
      if(strcasecmp(who, "PASS"))
      {
         if(cmd = strchr(line, ' ')) *cmd++ = '\0';
         if(rest = strchr(cmd, ' ')) *rest++ = '\0';
      }
      else
      {
         if(who = strchr(line, ' ')) *who++ = '\0';
         cmd = line;
         rest = NULL;
      }

   }

#ifdef DEBUG
printf("Parse - Command: [%s] Who: [%s] Rest: [%s]\n", cmd, who, rest);  
#endif
   if(!strcmp(cmd, "PRIVMSG") && strstr(rest, "@(!!)"))
   {
      nwho = nick2num(who);
      memcpy((char *) &id, &snum[5], sizeof(int));
      send_to_server(":%s NOTICE %s : %d\n", bot.nick, nwho, id);
      return;
   }
   if(who != NULL)
   {
      if(!strcmp(who, "SERVER") && !nick_server)
      {
         samp1=strtok(rest, " ");
         samp2=strtok(NULL, " ");
         samp3=strtok(NULL, " ");
         samp4=strtok(NULL, " ");
         samp5=strtok(NULL, " ");
         serv_used(*samp5, cmd);
      }
      if(!strcmp(cmd, "SERVER"))
      {
         who = test;
      }
   }
   for(i = 0; *parse_command[i].name; i++) 
   {
      if(!strcmp(cmd, parse_command[i].name)) 
      {
         parse_command[i].function(who, rest);
         return;
      }
   }
   
}
