/* NS1 - Nick Services ns-src/parse_mode.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_mode(char *who, char *rest)
{
   struct nickinfo *current;
   char *mode, *nick, *nnick, *tnick;
   int i = 0, j;
   if(mode = strchr(rest, ' ')) *mode++ = '\0'; /* -o all4u  0 */
   if(nick = strchr(mode, ' ')) *nick++ = '\0'; /* all4u 0 */
   switch(mode[0])
   {
      case '-': 
                if(nick[0] == '\0') return;
                if(strchr(mode, 'o'))
                {
                   tnick=strtok(nick, " ");
                   nnick=num2nick(tnick);
                   if(nnick == NULL) return;
                }
                return;
      case '+': 
                if(nick[0] == '\0') return;
                if(strchr(mode, 'o'))
                {
                   tnick=strtok(nick, " ");
                   nnick=num2nick(tnick);
                   if(nnick == NULL) return;
                }
                return;
        case ':':
                 if (strchr(mode,'o'))
                 {
                   current = nickhead;
                   while(current != NULL)
                   {
                     if(strcmp(who,current->nick) == 0)
                     {
                       break;
                     }
                     current = current->next;
                   }
                   if ( current != NULL )
                   {
                     if(strchr(mode,'+'))
                     {
                       current->is_oper=TRUE;
                     }
                     else
                     {
                       current->is_oper=FALSE;
                     }
                   }
                 }
                 break;
   }
   return;
}
