/* NS1 - Nick Services ns-src/reg_nick.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void reg_nick(char *who, char *rest)
{
   char *ptr = NULL , *uhost = NULL , usrhost[100], *caddr = NULL , ip_addr[20], *ptr2 = NULL , *passwd = NULL , *nwho = NULL;
   char *foo = NULL, *bar = NULL, *ptr3 = NULL , *ptr4 = NULL , *ptr5 = NULL , buhost[10000], duhost[10000], *cryptpass;
   int i=0, howmany = 0;
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   
   usrhost[0] = '\0';
   ip_addr[0] = '\0';
   buhost[0] = '\0';
   duhost[0] = '\0';

   nwho=nick2num(who);
   if(strlen(rest) > 100) return;
   if(badnick(who) == -1)
   {
      send_to_server(":%s NOTICE %s : You cannot register an illegal nick.\n", bot.nick, nwho);
      return;
   }

   uhost=getuserhost(who);
   rnick = rnickhead;
   if(rest == NULL || rest[0] == '\0' || rest[0] == ' ')
   {
      send_to_server(":%s NOTICE %s : You need to include the password\n", bot.nick, nwho);
      return;
   }

   passwd = strtok(rest, " ");
   if(passwd == NULL || *passwd == '\0' || *passwd == ' ')
   {
      send_to_server(":%s NOTICE %s : You need to include the password\n", bot.nick, nwho);
      return;
   }
   while(rnick != NULL)
   {
      if(!strcasecmp(who, rnick->nick))
      {
         adder = rnick->adderhead;
         {
            if(!bancmp(adder->address, uhost))
            {
               send_to_server(":%s NOTICE %s : You have already registered that nick\n", bot.nick, nwho, who);
               return;
            }
            adder = adder->next;
         }
      }
      rnick = rnick->next;
   }
   rnick = rnickhead;
   while(rnick != NULL)
   {
      adder = rnick->adderhead;
      while(adder != NULL)
      {
         if(!bancmp(adder->address, uhost))
         {
            i++;
            if(i == maxrnicks)
            {
                send_to_server(":%s NOTICE %s : You can only register %d Nicks\n", bot.nick, nwho, maxrnicks);
                return;
            }
         }
         adder = adder->next;
      }
      rnick = rnick->next;
   }
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(who, rnick->nick))
      {
          send_to_server(":%s NOTICE %s : Nice try, but you have already been notified that %s is a registered nick\n", bot.nick, nwho, who);
          return;
      }
      rnick = rnick->next;
   }
   if((uhost = getuserhost(who)) == NULL) return;
   ptr = strchr(uhost, '@');
   ptr++;
   if(!is_ip(ptr))
   {
      strcpy(buhost, uhost);
      strcpy(duhost, uhost);
      howmany = countdots(ptr);

      if(howmany == 1)
      {
         if((caddr = convert_addr(who, buhost)) != NULL)
            sprintf(ip_addr, "*%s", caddr);
         sprintf(usrhost, "*%s", uhost);
      }
      else if(howmany == 3 || howmany == 2)
      {
         if((caddr = convert_addr(who, buhost)) != NULL)
             sprintf(ip_addr, "*%s", caddr);
         if(ptr = strchr(uhost, '@')) *ptr++ = '\0';
          if(ptr2 = strchr(ptr, '.')) *ptr2++ = '\0';
          sprintf(usrhost, "*%s@*.%s", uhost, ptr2);
      }
      if(howmany == 4)
      {
         if((caddr = convert_addr(who, buhost)) != NULL)
             sprintf(ip_addr, "*%s", caddr);
         if(ptr = strchr(uhost, '@')) *ptr++ = '\0';
          if(ptr2 = strchr(ptr, '.')) *ptr2++ = '\0';
          if(ptr3 = strchr(ptr2, '.')) *ptr3++ = '\0';
          if(ptr4 = strchr(ptr3, '.')) *ptr4++ = '\0';
          sprintf(usrhost, "*%s@*.%s", uhost, ptr4);
      }
      if(howmany >= 5)
      {
         if((caddr = convert_addr(who, buhost)) != NULL)
             sprintf(ip_addr, "*%s", caddr);
         if(ptr = strchr(uhost, '@')) *ptr++ = '\0';
          if(ptr2 = strchr(ptr, '.')) *ptr2++ = '\0';
          if(ptr3 = strchr(ptr2, '.')) *ptr3++ = '\0';
          if(ptr4 = strchr(ptr3, '.')) *ptr4++ = '\0';
          if(ptr5 = strchr(ptr4, '.')) *ptr5++ = '\0';
          sprintf(usrhost, "*%s@*.%s", uhost, ptr5);
      }
   }
   else
   {
      if(ptr = strrchr(uhost, '.'))
      {
         *++ptr = '*';
         *++ptr = '\0';
      }
      sprintf(usrhost, "*%s", uhost);
   }
   if(strlen(passwd) > 8)
   {
      send_to_server(":%s NOTICE %s :Password can only be 8 characters\n", bot.nick, nwho);
      send_to_server(":%s NOTICE %s :Password NOT Changed\n", bot.nick, nwho);
      return;
   }
   cryptpass = mkpass(passwd, "0");
   add_rnickinfo(who, cryptpass, time(NULL), FALSE, FALSE, FALSE);
   if(caddr == NULL)
   {
      add_rnick_addrinfo(who, usrhost);
   }
   if(caddr != NULL)
   {
      add_rnick_addrinfo(who, usrhost);
      add_rnick_addrinfo(who, ip_addr);
   }
   send_to_server(":%s NOTICE %s : You have registered Nick %s Hostmask %s Password %s\n", bot.nick, nwho, who, usrhost, passwd);
   send_to_server(":%s NOTICE %s : Please Remember your password, and they are case sensitive\n", bot.nick, nwho, who, usrhost, passwd);
   write_rnickfile();
}
