/* NS1 - Nick Services ns-src/bancmp.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

int bancmp(const char *mask, const char *name)
{
  const char *m = mask;
  const char *n = name;
  const char *ma = mask;
  const char *na = name;
  int wild = 0;
  int q = 0;

  while (1)
  {
    if (*m == '*')
    {
      while (*m == '*')
	m++;
      wild = 1;
      ma = m;
      na = n;
    }

    if (!*m)
    {
      if (!*n)
        return 0;
      for (m--; (m > mask) && (*m == '?'); m--)
	;
      if ((*m == '*') && (m > mask) &&
	  (m[-1] != '\\'))
        return 0;
      if (!wild)
	return 1;
      m = ma;
      n = ++ na;
    }
    else if (!*n)
    {
      while (*m == '*')
	m++;
      return (*m != 0);
    }
    if ((*m == '\\') && ((m[1] == '*') || (m[1] == '?')))
    {
      m++;
      q = 1;
    }
    else
      q = 0;

    if ((tolower(*m) != tolower(*n)) && ((*m != '?') || q))
    {
      if (!wild)
	return 1;
      m = ma;
      n = ++na;
    }
    else
    {
      if (*m)
	m++;
      if (*n)
	n++;
    }
  }
}

char *collapse(char *pattern)
{
  Reg1 char *s = pattern, *s1, *t;

  if (BadPtr(pattern))
    return pattern;
  for (; *s; s++)
    if (*s == '\\')
      if (!*(s + 1))
	break;
      else
	s++;
    else if (*s == '*')
    {
      if (*(t = s1 = s + 1) == '*')
	while (*t == '*')
	  t++;
      else if (*t == '?')
	for (t++, s1++; *t == '*' || *t == '?'; t++)
	  if (*t == '?')
	    *s1++ = *t;
      while ((*s1++ = *t++));
    }
  return pattern;
}
