/* NS1 - Nick Services ns-src/del_nick.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void delete_rnick(char *who, char *rest)
{
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   char *nick, *nwho;

   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(who, rnick->nick))  
      {
          delete_rnode(who);
          send_to_server(":%s NOTICE %s : Nick %s has been dropped\n", bot.nick, nwho, who);
          write_rnickfile();
          return;
      }
      rnick=rnick->next;
   }
}

void delete_rnode(char *nick)
{
   struct rnickinfo *current, *previous, *tmp;
   struct adderinfo *current1, *previous1, *tmp1;
   struct killinfo *kills;
   int found = 0;
   char nnick[10];

   kills = killhead;
   while(kills != NULL)
   {
      if(!strcasecmp(nick, kills->nick))
      {
         found = 1;
         strcpy(nnick, kills->numeric);
         break;
      }
      kills = kills->next;
   }
   if(found)
      delete_kill(nick, nnick);
   current = rnickhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick, current->nick)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      current1 = current->adderhead;
      while(current1 != NULL)
      {
         if(current1 == current->adderhead) current->adderhead = current->adderhead->next;
         else previous1->next = current1->next;
         tmp1 = current1->next;
         free(current1);
         current1=tmp1;
      }      
      if(current == rnickhead) rnickhead = rnickhead->next;
      else previous->next = current->next;
      free(current);
      return;
   }
}
