struct burstinfo
{
   char channel[201];
   long chanstamp;
   struct burstinfo *next;
};

struct badinfo
{
   char nick[100];
   struct badinfo *next;
};

struct templist
{
  char nick[5];
  char numeric[210];
  struct templist *next;
};

struct rnickinfo
{
   char nick[50];
   char pass[100];
   char numeric[4];
   long stamp;
   int authed;
   int admin;
   int kills;
   int purge;
   struct adderinfo *adderhead;
   struct rnickinfo *next;
};

struct adderinfo
{
   char address[100];
   struct adderinfo *next;
};

struct killinfo
{
   char nick[100];
   char numeric[100];
   long timestamp;
   struct killinfo *next;
};

struct hubinfo
{
   char main[100];
   char link[100];
   struct hubinfo *next;
   struct hubinfo *prev;
};

struct usernums
{
   char nick[20];
   char chars[4];
   int used;
};

struct servinfo
{
   char server[100];
   char chars;
   int used;
};

struct SERVERS
{
   char name[80];
   int port;
};

struct HELPLIST
{
   char name[30];
   long pos;
};

struct nickinfo 
{
   char nick[50];
   char user[50];
   char host[100];
   char server[100];
   char base64[10];
   char numeric[3];
   int is_oper;
   struct nickinfo *next;
};

struct flooding 
{
   char name[50];
   long time;
   int count;
   int bool;
   int kick;
};

struct bots 
{
   char nick[NICKLEN];
   char ircname[MAXDEF];
   char username[MAXDEF];
   char server[MAXDEF];
   int port;
   long lastpinged;
   int server_active;
};

struct PARSE_COMMAND
{
   char *name;
   void (*function)(char *, char *);
}; 

struct COMMANDS
{
   char name[30];
   char realname[30];
   void (*function)(char *, char *);
   int level;
   int needarg;
   int disable;
}; 

struct sortit
{
   char name[30];
   int level;
};
