/* NS1 - Nick Services ns-src/node_tools.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

int delete_addrnode(char *who, char *addr)
{
   struct rnickinfo *rnick;
   struct adderinfo *current, *previous;

         rnick = rnickhead;
         while(rnick != NULL)
         {
            if(!strcasecmp(who, rnick->nick))
            {
               current = rnick->adderhead;
               if(current->next == NULL) return 0;
               while(current != NULL)
               {
                  if(!strcasecmp(addr, current->address)) break;
                  else
                  {
                     previous = current;
                     current = current->next;
                  }
               }
               if(current == NULL) return 2;
               else
               {
                  if(current == rnick->adderhead) rnick->adderhead = rnick->adderhead->next;
                  else previous->next = current->next;
                  free(current);
                  return 1;
               }

            }
            rnick = rnick->next;
   }
   return 2;
}

void replace_rnick(char *rnick, char *uhost)
{
/*
   struct rnickinfo *current;
   struct adderinfo *adder;
   if(rnickhead == NULL) return;
   current = rnickhead;
   while(current != NULL)
   {
      if(!strcasecmp(rnick, current->nick))
      {
         strcpy(current->address, uhost);
         break;
      }
      current = current->next;
   }
*/
}

void replace_node(char *numeric, char *newnick)
{
   struct nickinfo *current;
   if(nickhead == NULL) return;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcmp(numeric, current->numeric))
      {
         strcpy(current->nick, newnick);
      }
      current = current->next;
   }
}

void delete_snode(char *server)
{
   struct nickinfo *current;
   struct templist *temp;

   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(server, current->server))
      {
         add_templist(current->nick, current->numeric);
      }
      current = current->next;
   }
   temp = listhead;
   while(temp != NULL)
   {
       delete_node(temp->numeric);
       temp = temp->next;
   }
   free_templist();
}

void delete_kill(char *nick, char *numeric)
{
   struct killinfo *current, *previous, *tmp;

   current = killhead;
   while(current != NULL)
   {
      if(!strcmp(numeric, current->numeric) && !strcasecmp(nick, current->nick))
      {
         if(current == NULL) return;
         else
         {
            if(current == killhead) killhead = killhead->next;
            else previous->next = current->next;
            tmp=current;
            current = current->next;
            free(tmp);
         }
      }
      else
      {
         previous = current;
         current = current->next;
      }
   }
}

void delete_node(char *numeric)
{
   struct nickinfo *current, *previous, *tmp;
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   char *uhost, *nwho;

   rnick = rnickhead;
   while (rnick != NULL)
   {
      if(!strcmp(numeric, rnick->numeric))
      {
          delete_kill(rnick->nick, numeric);
          rnick->authed = 0;
      }
      rnick = rnick->next;
   }
   current = nickhead;
   while(current != NULL)
   {
      if(!strcmp(numeric, current->numeric))
      {
         if(current == NULL) return;
         else
         {
            if(current == nickhead) nickhead = nickhead->next;
            else previous->next = current->next;
            tmp=current;
            current = current->next;
            free(tmp);
         }
      }
      else
      {
         previous = current;
         current = current->next;
      }
   }
}
