/* NS1 - Nick Services ns-src/parse_srvmsg.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_server_msg(fd_set *read_fds)
{
   char *botnum;
   int i;

   if(FD_ISSET(socketfd, read_fds))
   {
      if(readln() > 0)
      {
         parse(line);
      }
      else
      {
         botnum=get_usernum(bot.nick);
         delete_usernum(botnum);
         free_nicklist();
         if(trk_servers >= no_servers) trk_servers = 0;
         strcpy(bot.server, servers[trk_servers].name);
         bot.port = servers[trk_servers].port;
         trk_servers++;
         if((i = get_connection(bot.server, bot.port)) != -1)
         {
            log(LOG_FILE, "[%s] Reconnecting to %s\n", date(), bot.server);
            socketfd = i;
            init_bot();
         }
      }
   }
}

void parse_ping(char *who, char *rest)
{
   /* rest is NULL, so don't try anything.. it will SIGSEGV */
   /* who will have ':' intact */
   send_to_server("PONG %s\n", who);
   bot.server_active = TRUE;
}


void parse_pong(char *who, char *rest)
{
   char *ptr;
   if(ptr = strchr(rest, ' ')) *ptr = '\0';
   if(!strcasecmp(who, rest)) bot.server_active = TRUE;
}

void parse_squit(char *who, char *rest)
{
   char *server;

   server = strtok(rest, " ");
   if(strcasecmp(server, xserver))
   remove_hub(server,NULL);
}

void parse_pass(char *who, char *rest)
{
   char *usernum, *usernum1;

   usernum=get_free_usernum(bot.nick);
   send_to_server("%c NICK %s 1 %lu %s %s DQx8MG %s :%s\n", convert2y[server_num], bot.nick, time(NULL), ircuser, myhost, usernum, ircname);
   send_to_server(":%s MODE %s :%s\n", bot.nick, bot.nick, mymodes);
   bot.server_active = TRUE;  /* lets assume server is active */
   alarm(ALARMINTERVAL);
}
