/* NS1 - Nick Services ns-src/rnick_purge.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void check_rnick_purge_time()
{
   int found = 0;
   struct rnickinfo *current;
   struct templist *temp;

   current = rnickhead;
   while(current != NULL)
   {
      if(!current->purge)
      {
         if((time(NULL) - current->stamp) >= purge_time)
         {
            log(PURGE_LOG, "[%s] Registered Nick %s purged, Nick has not been authed within %d days\n", date(), current->nick, (((purge_time/60)/60)/24));
            add_templist(current->nick, NULL);
         }
      }
      current = current->next;
   }
   temp = listhead;
   while(temp != NULL)
   {
       delete_rnode(temp->nick);
       temp = temp->next;
   }
   free_templist();
   write_rnickfile();
}
